#!/usr/bin/perl

# Given the output of repeat.pl as stdin, produce interesting stats.

@sums   = (0, 0, 0);
@counts = (0, 0, 0);
@col0 = ();
@col1 = ();
@col2 = ();

while (<STDIN>) {

    if (/^(\d+\.\d+)\D+(\d+\.\d+)\D+(\d+\.\d+)\D+/) {
#	print  $1, " ", $2, " ", $3, "\n";

	$sums[0] += $1;
	$sums[1] += $2;
	$sums[2] += $3;
	
	push @col0, ($1);
	push @col1, ($2);
	push @col2, ($3);
	
	$counts[0]++;
	$counts[1]++;
	$counts[2]++;
	
    } else {
	print $_;
    }

}


do_stats (@sums, @counts, 
	  @col0, @col1, @col2);
exit;

sub do_stats {
    my($sums, $counts, $col0, $col1, $col2) = @_;
    
    $avg0 = $sums[0] / $counts[0];
    $avg1 = $sums[1] / $counts[1];
    $avg2 = $sums[2] / $counts[2];
    
    printf ("Averages:\n");
    printf ("%10f %10f %10f\n",
	    $avg0,
	    $avg1,
	    $avg2);
    
    @sort0 = sort {$a <=> $b} @col0;
    @sort1 = sort {$a <=> $b} @col1;
    @sort2 = sort {$a <=> $b} @col2;
    
    printf ("Median:\n");
    printf ("%10f %10f %10f\n",
	    $sort0[$#col0/2],
	    $sort1[$#col1/2],
	    $sort2[$#col2/2]);

    printf ("Minimum and 100*(avg - min)/avg:\n");
    printf ("%10f %10f %10f\n",
	    $sort0[0],
	    $sort1[0],
	    $sort2[0]);

    printf ("%10.2f%% %10.2f%% %10.2f%%\n",
	    100*($avg0 - $sort0[0])/$avg0,
	    100*($avg1 - $sort1[0])/$avg1,
	    100*($avg2 - $sort2[0])/$avg2);
    
    
    printf ("Maximum and 100*(max - avg)/avg:\n");
    printf ("%10f %10f %10f\n",
	    $sort0[$#col0],
	    $sort1[$#col1],
	    $sort2[$#col2]);
    
    printf ("%9.2f%% %9.2f%% %9.2f%%\n\n\n",
	    100*($sort0[$#col0] - $avg0)/$avg0,
	    100*($sort1[$#col1] - $avg1)/$avg1,
	    100*($sort2[$#col2] - $avg2)/$avg2);
}




