#!/usr/local/bin/perl

# Given the output of repeat.pl as stdin, produce interesting stats.

$start = 1;

while (<STDIN>) {
    if (/^Duration.*/ ) {
	
	if ($start != 1) {
	    # Compute stats
	    do_stats (@sums);
    
	} else {
	    $start = 0;
	}

	print;
	@sums   = (0, 0, 0, 0, 0, 0, 0);

    } else {
	print;
	if (/\w*\s+([\.\d]+)\D+([\.\d]+)\D+([\.\d]+)\D+([\.\d]+)\D+([\.\d]+)\D+([\.\d]+)\D+([\.\d]+)\D+/) {

	    $sums[0] += $1;
	    $sums[1] += $2;
	    $sums[2] += $3;
	    $sums[3] += $4;
	    $sums[4] += $5;
	    $sums[5] += $6;
	    $sums[6] += $7;
	    
	}
    }
}


do_stats (@sums);
exit;

sub do_stats {
    my($sums) = @_;
        
    printf ("Sums:\n");
    printf ("%16d %10d %10f %6lu %6lu %8.2f %8.2f\n\n\n",
	    $sums[0],
	    $sums[1],
	    $sums[2],
	    $sums[3],
	    $sums[4],
	    $sums[5],
	    $sums[6],
	    );
}




