# The RPM will fail to build with some versions of gcc 2.96, which is
# default in the RH7.x distributions.  If "rpmbuild -ba sfs-0.7.spec"
# fails and you have gcc 2.96, install the following packages from the
# RH7.2 updates:
#   gcc3-3.0.4-1.i386.rpm      libstdc++3-3.0.4-1.i386.rpm
#   gcc3-c++-3.0.4-1.i386.rpm  libstdc++3-devel-3.0.4-1.i386.rpm
#   libgcc-3.0.4-1.i386.rpm
# and then run "rpmbuild -ba sfs-0.7.spec --with gcc3".  No gcc3
# packages are available in RH7.3, but the RH7.2 updates appear to work
# on RH7.3. 

Summary: SFS -- a secure, decentralized, global file system
Name: sfs
Version: 0.7
Release: 2
Copyright: GPL 
Group: Applications/File
Source: http://www.fs.net/download/sfs-%{version}.tar.gz 
URL: http://www.fs.net/
Packager: SFS Developers <http://www.fs.net/>
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot
Requires: kernel >= 2.2.14, gmp >= 2.0
Obsoletes: sfs-devel

%if %{?_with_gcc3:1}%{!?_with_gcc3:0}
BuildRequires: gcc3, gcc3-c++
%else
BuildRequires: gcc, gcc-c++
BuildConflicts: gcc = 2.96-85, gcc-c++ = 2.96-85, gcc = 2.96-98, gcc-c++ = 2.96-98,gcc = 2.96-108, gcc-c++ = 2.96-108, gcc = 2.96-110, gcc-c++ = 2.96-110
%endif


%package servers
Summary: SFS servers.
Group: Applications/File
PreReq: sfs = %{version}-%{release}
#Requires: nfs-server, db3 
Requires: nfs-server


%description
The Self-Certifying File System (SFS) is a secure, global file system
with completely decentralized control. SFS lets you access your files
from anywhere and share them with anyone, anywhere. Anyone can set up
an SFS server, and any user can access any server from any client. SFS
lets you share files across administrative realms without involving
administrators or certification authorities.

This file includes the core files necessary for SFS clients.  Also
included are libraries and header files useful for development of
SFS-enabled tools.


%description servers
The Self-Certifying File System (SFS).

This package includes servers of SFS services such as the remote
execution (Rex), the SFS read-write server, and the SFS read-only
server.


%prep
%setup -q

%build
if test -z "${DEBUG+set}"; then
    DEBUG=-O2
    export DEBUG
fi

%if %{?_with_gcc3:1}%{!?_with_gcc3:0}
env CC=gcc3 CXX=g++3 ./configure --prefix=/usr
%else
env CC=gcc CXX=g++ ./configure --prefix=/usr
%endif
make 

%install
rm -rf $RPM_BUILD_ROOT
make install-strip DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/var/sfs $RPM_BUILD_ROOT/etc/sfs $RPM_BUILD_ROOT/sfs
install -D -m 755 etc/sfscd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/sfscd
install -D -m 755 etc/sfssd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/sfssd

%clean
rm -rf $RPM_BUILD_ROOT

%pre
grep -q '^sfs:' /etc/passwd \
   || /usr/sbin/useradd -M -r -d /var/sfs -s /bin/true -c "SFS" sfs \
   || :
grep -q '^sfs:' /etc/group \
   || /usr/sbin/groupadd sfs 


%post
if [ $1 = 1 ]; then
  /sbin/chkconfig --add sfscd
  /bin/chown sfs.sfs /var/sfs
  /bin/chown sfs.sfs /sfs
fi
/bin/chown root.sfs /usr/lib/sfs/suidconnect
/bin/chmod g+s /usr/lib/sfs/suidconnect
/bin/chmod u+s /usr/lib/sfs/newaid
/sbin/install-info --info-dir=/usr/info /usr/info/sfs.info || :

%post servers
if [ $1 = 1 ]; then
  /sbin/chkconfig --add sfssd
fi

%preun
if [ "$1" = "0" ]; then
   /sbin/service sfscd stop > /dev/null 2>&1 || :
   /sbin/chkconfig --del sfscd
   /sbin/install-info --info-dir=/usr/info --remove /usr/info/sfs.info || :
fi

%preun servers
if [ "$1" = "0" ]; then
   /sbin/service sfssd stop > /dev/null 2>&1 || :
   /sbin/chkconfig --del sfssd
fi


%postun
if [ "$1" = "0" ]; then
   if grep -q '^sfs:.*:/var/sfs:' /etc/passwd; then
      /usr/sbin/userdel sfs
      if grep -q \^sfs: /etc/group; then
         /usr/sbin/groupdel sfs
      fi
   fi
   rm -rf /var/sfs/random_seed /var/sfs/sockets
fi

if [ $1 -ge 1 ]; then
  /sbin/service sfscd condrestart >/dev/null 2>&1 || :
fi


%postun servers
if [ "$1" = "0" ]; then
   rm -rf /var/sfs/authdb
fi

if [ $1 -ge 1 ]; then
  /sbin/service sfssd condrestart >/dev/null 2>&1 || :
fi

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog NEWS README STANDARDS TODO
%config /usr/share/sfs/agentrc
%config /usr/share/sfs/sfs_config
%config /usr/share/sfs/sfscd_config
%config /usr/share/sfs/sfs_srp_parms
%config /etc/rc.d/init.d/sfscd
/usr/info/sfs.info-2.gz
/usr/info/sfs.info-3.gz
#/usr/info/dir
/usr/info/sfs.info.gz
/usr/info/sfs.info-1.gz
/usr/man/man1/dirsearch.1.gz
/usr/man/man1/newaid.1.gz
/usr/man/man1/sfskey.1.gz
/usr/man/man1/rex.1.gz
/usr/man/man1/ssu.1.gz
/usr/man/man1/sfsagent.1.gz
/usr/man/man5/sfscd_config.5.gz
/usr/man/man5/sfs_config.5.gz
/usr/man/man5/sfs_srp_params.5.gz
/usr/man/man7/sfs.7.gz
/usr/man/man8/funmount.8.gz
/usr/man/man8/sfscd.8.gz
/usr/lib/libsfs.a
/usr/lib/sfs
/usr/lib/sfs-%{version}/aiod
/usr/lib/sfs-%{version}/libasync.la
/usr/lib/sfs-%{version}/libasync.a
/usr/lib/sfs-%{version}/libarpc.la
/usr/lib/sfs-%{version}/libarpc.a
/usr/lib/sfs-%{version}/libsfscrypt.la
/usr/lib/sfs-%{version}/libsfscrypt.a
/usr/lib/sfs-%{version}/libsvc.la
/usr/lib/sfs-%{version}/libsvc.a
/usr/lib/sfs-%{version}/pathinfo
/usr/lib/sfs-%{version}/suidconnect
/usr/lib/sfs-%{version}/libsfsmisc.la
/usr/lib/sfs-%{version}/libsfsmisc.a
/usr/lib/sfs-%{version}/mallock.o
/usr/lib/sfs-%{version}/nfsmounter
/usr/lib/sfs-%{version}/sfsrwcd
/usr/bin/newaid
/usr/lib/sfs-%{version}/newaid
/usr/lib/sfs-%{version}/xfer
/usr/lib/sfs-%{version}/connect
/usr/lib/sfs-%{version}/listen
/usr/lib/sfs-%{version}/moduled
/usr/bin/rpcc
/usr/bin/sfsacl
/usr/bin/sfsagent
/usr/bin/sfskey
/usr/bin/ssu
/usr/bin/dirsearch
/usr/bin/sfsproac
/usr/bin/sfsdeclog
/usr/bin/rex
/usr/sbin/funmount
/usr/sbin/sfscd
/usr/include/sfs
/usr/include/sfs-%{version}/aiod.h
/usr/include/sfs-%{version}/aiod_prot.h
/usr/include/sfs-%{version}/aios.h
/usr/include/sfs-%{version}/amisc.h
/usr/include/sfs-%{version}/arena.h
/usr/include/sfs-%{version}/array.h
/usr/include/sfs-%{version}/async.h
/usr/include/sfs-%{version}/backoff.h
/usr/include/sfs-%{version}/bbuddy.h
/usr/include/sfs-%{version}/bitvec.h
/usr/include/sfs-%{version}/callback.h
/usr/include/sfs-%{version}/cbuf.h
/usr/include/sfs-%{version}/dns.h
/usr/include/sfs-%{version}/dnsparse.h
/usr/include/sfs-%{version}/err.h
/usr/include/sfs-%{version}/fdlim.h
/usr/include/sfs-%{version}/ihash.h
/usr/include/sfs-%{version}/init.h
/usr/include/sfs-%{version}/itree.h
/usr/include/sfs-%{version}/keyfunc.h
/usr/include/sfs-%{version}/list.h
/usr/include/sfs-%{version}/msb.h
/usr/include/sfs-%{version}/opnew.h
/usr/include/sfs-%{version}/parseopt.h
/usr/include/sfs-%{version}/pcre.h
/usr/include/sfs-%{version}/qhash.h
/usr/include/sfs-%{version}/refcnt.h
/usr/include/sfs-%{version}/rxx.h
/usr/include/sfs-%{version}/serial.h
/usr/include/sfs-%{version}/stllike.h
/usr/include/sfs-%{version}/str.h
/usr/include/sfs-%{version}/suio++.h
/usr/include/sfs-%{version}/sysconf.h
/usr/include/sfs-%{version}/union.h
/usr/include/sfs-%{version}/vatmpl.h
/usr/include/sfs-%{version}/vec.h
/usr/include/sfs-%{version}/rwfd.h
/usr/include/sfs-%{version}/pmap_prot.x
/usr/include/sfs-%{version}/aclnt.h
/usr/include/sfs-%{version}/arpc.h
/usr/include/sfs-%{version}/asrv.h
/usr/include/sfs-%{version}/axprt.h
/usr/include/sfs-%{version}/pmap_prot.h
/usr/include/sfs-%{version}/rpctypes.h
/usr/include/sfs-%{version}/xdr_suio.h
/usr/include/sfs-%{version}/xdrmisc.h
/usr/include/sfs-%{version}/xhinfo.h
/usr/include/sfs-%{version}/crypt_prot.x
/usr/include/sfs-%{version}/aes.h
/usr/include/sfs-%{version}/arc4.h
/usr/include/sfs-%{version}/axprt_crypt.h
/usr/include/sfs-%{version}/bench.h
/usr/include/sfs-%{version}/bigint.h
/usr/include/sfs-%{version}/blowfish.h
/usr/include/sfs-%{version}/crypt.h
/usr/include/sfs-%{version}/crypthash.h
/usr/include/sfs-%{version}/crypt_prot.h
/usr/include/sfs-%{version}/esign.h
/usr/include/sfs-%{version}/hashcash.h
/usr/include/sfs-%{version}/modalg.h
/usr/include/sfs-%{version}/password.h
/usr/include/sfs-%{version}/prime.h
/usr/include/sfs-%{version}/prng.h
/usr/include/sfs-%{version}/rabin.h
/usr/include/sfs-%{version}/seqno.h
/usr/include/sfs-%{version}/sha1.h
/usr/include/sfs-%{version}/srp.h
/usr/include/sfs-%{version}/tiger.h
/usr/include/sfs-%{version}/wmstr.h
/usr/include/sfs-%{version}/schnorr.h
/usr/include/sfs-%{version}/nfs_prot.x
/usr/include/sfs-%{version}/nfs3_prot.x
/usr/include/sfs-%{version}/nfs3exp_prot.x
/usr/include/sfs-%{version}/nfs3close_prot.x
/usr/include/sfs-%{version}/mount_prot.x
/usr/include/sfs-%{version}/sfs_prot.x
/usr/include/sfs-%{version}/sfsauth_prot.x
/usr/include/sfs-%{version}/sfsagent.x
/usr/include/sfs-%{version}/sfscd_prot.x
/usr/include/sfs-%{version}/nfsmounter.x
/usr/include/sfs-%{version}/sfsro_prot.x
/usr/include/sfs-%{version}/rex_prot.x
/usr/include/sfs-%{version}/nfs3_ext.x
/usr/include/sfs-%{version}/nfs_prot.h
/usr/include/sfs-%{version}/nfs3_prot.h
/usr/include/sfs-%{version}/nfs3exp_prot.h
/usr/include/sfs-%{version}/nfs3close_prot.h
/usr/include/sfs-%{version}/mount_prot.h
/usr/include/sfs-%{version}/sfs_prot.h
/usr/include/sfs-%{version}/sfsauth_prot.h
/usr/include/sfs-%{version}/sfsagent.h
/usr/include/sfs-%{version}/sfscd_prot.h
/usr/include/sfs-%{version}/nfsmounter.h
/usr/include/sfs-%{version}/sfsro_prot.h
/usr/include/sfs-%{version}/rex_prot.h
/usr/include/sfs-%{version}/sfs-internal.h
/usr/include/sfs-%{version}/afsnode.h
/usr/include/sfs-%{version}/agentconn.h
/usr/include/sfs-%{version}/agentmisc.h
/usr/include/sfs-%{version}/getfh3.h
/usr/include/sfs-%{version}/nfs3_nonnul.h
/usr/include/sfs-%{version}/nfsserv.h
/usr/include/sfs-%{version}/nfstrans.h
/usr/include/sfs-%{version}/rex.h
/usr/include/sfs-%{version}/sfsclient.h
/usr/include/sfs-%{version}/sfsconnect.h
/usr/include/sfs-%{version}/sfskeymisc.h
/usr/include/sfs-%{version}/sfsmisc.h
/usr/include/sfs-%{version}/sfsserv.h
/usr/include/sfs-%{version}/sfstty.h
/usr/include/sfs-%{version}/uvfstrans.h
/usr/include/sfs-%{version}/sfscrypt.h
/usr/include/sfs-%{version}/sfsschnorr.h
/usr/include/sfs-%{version}/sfsextauth.h
/usr/include/sfs-%{version}/sfskeymgr.h
/usr/include/sfs-%{version}/autoconf.h
/usr/include/sfs.h
%dir /etc/sfs
%dir /sfs
%dir /var/sfs

%files servers
%defattr(-,root,root)
%config /usr/share/sfs/sfssd_config
%config /usr/share/sfs/sfsauthd_config
%config /etc/rc.d/init.d/sfssd
/usr/sbin/sfssd
/usr/sbin/vidb
/usr/man/man5/sfs_users.5.gz
/usr/man/man8/vidb.8.gz
/usr/man/man8/sfssd.8.gz
/usr/man/man8/sfsauthd.8.gz
/usr/man/man8/sfsrwsd.8.gz
/usr/man/man5/sfsauthd_config.5.gz
/usr/man/man5/sfsrwsd_config.5.gz
/usr/man/man5/sfssd_config.5.gz
/usr/lib/sfs-%{version}/sfsrwsd
/usr/lib/sfs-%{version}/sfsauthd
/usr/lib/sfs-%{version}/ptyd
/usr/lib/sfs-%{version}/rexd
/usr/lib/sfs-%{version}/proxy
/usr/lib/sfs-%{version}/ttyd


%changelog
* Mon Dec 2 2002 Kevin Fu <fubob@mit.edu>
- Merge the sfs-devel package into the core sfs package.  Move some 
  misplaced files between sfs and sfs-servers packages.

* Mon Dec 2 2002 Kevin Fu <fubob@mit.edu>
- Release of SFS 0.7

* Sun Dec 1 2002 Kevin Fu <fubob@mit.edu>
- Add conditional magic to avoid compiling with gcc 2.96

* Sat Nov 30 2002 Kevin Fu <fubob@mit.edu>
- Created new spec file based on sfs.spec and 0.7pre12 build
